## kwave 24.12.3

=== CMakeLists.txt ===
#############################################################################
##    Kwave                - CMakeLists.txt
##                           -------------------
##    begin                : Tue May 01 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
#                                                                           #
# Redistribution and use in source and binary forms, with or without        #
# modification, are permitted provided that the following conditions        #
# are met:                                                                  #
#                                                                           #
# 1. Redistributions of source code must retain the above copyright         #
#    notice, this list of conditions and the following disclaimer.          #
# 2. Redistributions in binary form must reproduce the above copyright      #
#    notice, this list of conditions and the following disclaimer in the    #
#    documentation and/or other materials provided with the distribution.   #
#                                                                           #
# For details see the accompanying cmake/COPYING-CMAKE-SCRIPTS file.        #
#                                                                           #
#############################################################################

# KDE Application Version, managed by release script
set (RELEASE_SERVICE_VERSION_MAJOR "24")
set (RELEASE_SERVICE_VERSION_MINOR "12")
set (RELEASE_SERVICE_VERSION_MICRO "3")

#############################################################################
### build options:                                                        ###

# OPTION(DEBUG           "build debug code [default=off]" OFF)
# OPTION(WITH_ALSA       "enable playback/recording via ALSA [default=on]" ON)
# OPTION(WITH_DOC        "build online documentation [default=on]" ON)
# OPTION(WITH_FLAC       "enable support for FLAC files [default=on]" ON)
# OPTION(WITH_MP3        "enable support for mp3 files [default=off]" OFF)
# OPTION(WITH_OGG_OPUS   "enable support for ogg/opus files [default=on]" ON)
# OPTION(WITH_OGG_VORBIS "enable support for ogg/vorbis files [default=on]" ON)
# OPTION(WITH_OSS        "enable playback/recording via OSS [default=on]" ON)
# OPTION(WITH_OPTIMIZED_MEMCPY "enable optimized memcpy [default=on]" ON)
# OPTION(WITH_PULSEAUDIO "enable playback/recording via PulseAudio [default=on]" ON)
# OPTION(WITH_QT_AUDIO   "enable playback via Qt Multimedia [default=on]" ON)

#############################################################################
### toplevel build targets:                                               ###

# all                 - default target, build all files
# clean               - clean up the current build directory
# deb                 - create a debian package
# doc                 - generate docbook files for online help
# distfiles           - generate subdirectory with all files for distribution
# html_doc            - generate HTML help (for the web)
# install             - install the package, with support for DESTDIR
# msgstats            - show the progress of translations
# rpm                 - create a RPM package + a src.rpm file
# src_rpm             - create the source RPM only
# tarball             - create a tar.bz2 archive with the sources + specfile
# uninstall           - uninstall the package, with support for DESTDIR
# update-translations - update translation files from KDE SVN
# version-labels      - update all version numbers and build dates
# tarball             - create a tar.gz file with the sources

#############################################################################
### required versions                                                     ###

CMAKE_MINIMUM_REQUIRED(VERSION 3.16.0 FATAL_ERROR)

SET(QT_MIN_VERSION "6.6.0")
SET(KF_MIN_VERSION "6.0.0")
SET(KDE_COMPILERSETTINGS_LEVEL "5.82")

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

#############################################################################
### Kwave version number                                                  ###

SET(KWAVE_VERSION_MAJOR ${RELEASE_SERVICE_VERSION_MAJOR})
SET(KWAVE_VERSION_MINOR ${RELEASE_SERVICE_VERSION_MINOR})
SET(KWAVE_VERSION_MICRO ${RELEASE_SERVICE_VERSION_MICRO})
SET(KWAVE_VERSION "${KWAVE_VERSION_MAJOR}.${KWAVE_VERSION_MINOR}.${KWAVE_VERSION_MICRO}")
MESSAGE(STATUS "Building Kwave version ${KWAVE_VERSION}")

#############################################################################
### project name and version                                              ###

PROJECT(kwave VERSION ${KWAVE_VERSION})

#############################################################################
### show the compiler name and version                                    ###

EXECUTE_PROCESS(
    COMMAND ${CMAKE_C_COMPILER} -dumpversion
    OUTPUT_VARIABLE COMPILER_VERSION
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
GET_FILENAME_COMPONENT(COMPILER_SHORT "${CMAKE_C_COMPILER}" NAME_WE CACHE)
MESSAGE(STATUS "Building with ${COMPILER_SHORT} version ${COMPILER_VERSION}")

#############################################################################
### check for the CPU we build for                                        ###

EXECUTE_PROCESS(
    COMMAND ${CMAKE_C_COMPILER} -dumpmachine
    OUTPUT_VARIABLE MACHINE
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
MESSAGE(STATUS "Building for target ${MACHINE}")

OPTION(WITH_OPTIMIZED_MEMCPY "enable optimized memcpy [default=on]" ON)
IF (WITH_OPTIMIZED_MEMCPY)

    STRING(REGEX MATCH "(i.86-*)|(athlon-*)|(pentium-*)" _mach_x86 ${MACHINE})
    IF (_mach_x86)
        MESSAGE(STATUS "Found target optimized memcpy() for X86 (from xine)")
        SET(ARCH_X86 1)
    ENDIF (_mach_x86)

    STRING(REGEX MATCH "(x86_64-*)|(X86_64-*)|(AMD64-*)|(amd64-*)" _mach_x86_64 ${MACHINE})
    IF (_mach_x86_64)
        MESSAGE(STATUS "Found target optimized memcpy() for X86_64 (from xine)")
        SET(ARCH_X86_64 1)
    ENDIF (_mach_x86_64)

    STRING(REGEX MATCH "(ppc-*)|(powerpc-*)" _mach_ppc ${MACHINE})
    IF (_mach_ppc)
        MESSAGE(STATUS "Found target optimized memcpy() for PPC (from xine)")
        SET(ARCH_PPC 1)
    ENDIF (_mach_ppc)

    IF (NOT ARCH_X86 AND NOT ARCH_X86_64 AND NOT ARCH_PPC)
        MESSAGE(STATUS "No platform specific memcpy available")
    ENDIF (NOT ARCH_X86 AND NOT ARCH_X86_64 AND NOT ARCH_PPC)

ELSE (WITH_OPTIMIZED_MEMCPY)
    MESSAGE(STATUS "Platform specific memcpy is disabled")
ENDIF (WITH_OPTIMIZED_MEMCPY)

#############################################################################
### path to additional cmake modules and includes                         ###

SET(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

#############################################################################
### cmake includes                                                        ###

INCLUDE(CheckIncludeFiles)
INCLUDE(CheckIncludeFilesCXX)
INCLUDE(CheckCCompilerFlag)
INCLUDE(CheckTypeSize)
INCLUDE(CheckFunctionExists)
INCLUDE(FindRequiredProgram)

#############################################################################
### toplevel compiler flags                                               ###

ADD_DEFINITIONS(-DHAVE_CONFIG_H)
ADD_DEFINITIONS(-DQT_NO_CAST_TO_ASCII)
ADD_DEFINITIONS(-DQT_NO_CAST_FROM_ASCII)
ADD_DEFINITIONS(-DQT_USE_FAST_OPERATOR_PLUS)
ADD_DEFINITIONS(-DQT_NO_URL_CAST_FROM_STRING)

#############################################################################

LINK_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/libgui)
LINK_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/libkwave)

#############################################################################
### Qt support                                                            ###

SET(CMAKE_AUTOMOC TRUE)
SET(CMAKE_AUTOMOC_RELAXED_MODE FALSE)

FIND_PACKAGE(Qt6 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS
    Concurrent
    Core
    Widgets
)

# NOTE: this must be *after* FIND_PACKAGE(Qt5 Core ...), otherwise it would
#       be overwritten and produce many annoying build warnings
LIST(APPEND CMAKE_AUTOMOC_MACRO_NAMES "KWAVE_PLUGIN")

# Qt Multimedia support
OPTION(WITH_QT_AUDIO "enable playback via Qt Multimedia [default=on]" ON)
IF (WITH_QT_AUDIO)
    SET(HAVE_QT_AUDIO_SUPPORT on)
    FIND_PACKAGE(Qt6 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS
        Multimedia
    )
ENDIF (WITH_QT_AUDIO)


#############################################################################
### KF support                                                            ###

FIND_PACKAGE(ECM ${KF_MIN_VERSION} REQUIRED NO_MODULE)
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH}  )

INCLUDE(KDEInstallDirs)
INCLUDE(KDECompilerSettings NO_POLICY_SCOPE)
INCLUDE(KDECMakeSettings)
INCLUDE(ECMGenerateExportHeader)
INCLUDE(FeatureSummary)
INCLUDE(ECMDeprecationSettings)
ecm_set_disabled_deprecation_versions(
  QT 6.7.0
  KF 6.5.0
)

FIND_PACKAGE(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS
    Archive
    Completion
    Config
    ConfigWidgets
    CoreAddons
    Crash
    DBusAddons
    DocTools
    I18n
    IconThemes
    KIO
    TextWidgets
    XmlGui
    WidgetsAddons
)

IF (NOT WITH_DOC)
    SET_PACKAGE_PROPERTIES(KF6DocTools
        PROPERTIES DESCRIPTION "Tools to generate documentation"
        TYPE OPTIONAL
    )
ENDIF (NOT WITH_DOC)

FEATURE_SUMMARY(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

INCLUDE_DIRECTORIES(
    ${INTERFACE_INCLUDE_DIRECTORIES}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
)

#############################################################################

if(BUILD_TESTING)
    find_package(Qt6 ${QT_MIN_VERSION} REQUIRED Test)
    include(ECMAddTests)
endif()

#############################################################################
### checks for needed header files                                        ###

CHECK_INCLUDE_FILES(signal.h HAVE_SIGNAL_H)

SET(_inc_c errno.h math.h signal.h stdlib.h string.h unistd.h pthread.h)
CHECK_INCLUDE_FILES("${_inc_c}" HAVE_REQUIRED_STD_C_HEADERS)
IF (NOT HAVE_REQUIRED_STD_C_HEADERS)
    MESSAGE(FATAL_ERROR "
        unable to find one or more of the following C header files:
        ${_inc_c}")
ENDIF (NOT HAVE_REQUIRED_STD_C_HEADERS)

SET(_inc_cpp algorithm complex limits new)
CHECK_INCLUDE_FILES_CXX("${_inc_cpp}")

#############################################################################
### libaudiofile and libsamplerate support                                ###

INCLUDE(KwaveLibaudiofileSupport)
INCLUDE(KwaveLibsamplerateSupport)

#############################################################################
### optionally: OSS, ALSA and PulseAudio support                          ###
### for playback/recording                                                ###

INCLUDE(KwaveOSSSupport)
INCLUDE(KwaveALSASupport)
INCLUDE(KwavePulseAudioSupport)

#############################################################################
### cmake includes                                                        ###

INCLUDE(KwaveL10N)

#############################################################################
### flags for debugging                                                   ###

OPTION(DEBUG "enable the debug plugin in the menu [default=off]" OFF)
IF (DEBUG)
    SET(HAVE_DEBUG_PLUGIN  ON CACHE BOOL "enable debug plugin in the menu")
ENDIF (DEBUG)

#############################################################################
### subdirs                                                               ###

ADD_SUBDIRECTORY( libgui )
ADD_SUBDIRECTORY( libkwave )
ADD_SUBDIRECTORY( kwave )
ADD_SUBDIRECTORY( plugins )

OPTION(WITH_DOC "build online documentation [default=on]" ON)

=== kwave/CMakeLists.txt ===
#############################################################################
##    Kwave                - kwave/CMakeLists.txt
##                           -------------------
##    begin                : Wed May 09 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
#                                                                           #
# Redistribution and use in source and binary forms, with or without        #
# modification, are permitted provided that the following conditions        #
# are met:                                                                  #
#                                                                           #
# 1. Redistributions of source code must retain the above copyright         #
#    notice, this list of conditions and the following disclaimer.          #
# 2. Redistributions in binary form must reproduce the above copyright      #
#    notice, this list of conditions and the following disclaimer in the    #
#    documentation and/or other materials provided with the distribution.   #
#                                                                           #
# For details see the accompanying cmake/COPYING-CMAKE-SCRIPTS file.        #
#                                                                           #
#############################################################################

INCLUDE(ECMInstallIcons)

#############################################################################

SET(kwave_SRCS
    App.cpp
    FileContext.cpp
    main.cpp
    MainWidget.cpp
    PlayerToolBar.cpp
    ShortcutWrapper.cpp
    Splash.cpp
    TopWidget.cpp
    ZoomToolBar.cpp

    App.h
    FileContext.h
    MainWidget.h
    PlayerToolBar.h
    ShortcutWrapper.h
    Splash.h
    TopWidget.h
    ZoomToolBar.h
)

#############################################################################
### some pixmaps to be installed in the data dir                          ###

SET(kwave_PIXMAPS
    pics/amplify_free.png
    pics/fade_in.png
    pics/fade_out.png
    pics/knob.xpm
    pics/kwave-splash.png
    pics/light_off.xpm
    pics/light_on.xpm
    pics/logo.xpm
    pics/noise.png
    pics/selectedknob.xpm
    pics/sound_card.png
    pics/sound_device.png
    pics/sound_note.png
    pics/sound_subdevice.png
)

#############################################################################

ADD_EXECUTABLE(kwave_core ${kwave_SRCS})

#############################################################################

TARGET_LINK_LIBRARIES(kwave_core
    libkwavegui
    libkwave
    ${LIBAUDIOFILE_LINK_LIBRARIES}
    ${SAMPLERATE_LINK_LIBRARIES}
    Qt::Core
    Qt::Widgets
    KF6::Completion
    KF6::ConfigCore
    KF6::Crash
    KF6::DBusAddons
    KF6::I18n
    KF6::IconThemes
    KF6::KIOFileWidgets
    KF6::XmlGui
)

SET_TARGET_PROPERTIES(kwave_core PROPERTIES
    OUTPUT_NAME "kwave"
    ENABLE_EXPORTS TRUE
)

#############################################################################
### install files                                                         ###

# the main program
INSTALL(TARGETS kwave_core     DESTINATION ${KDE_INSTALL_BINDIR})

# other files
INSTALL(FILES menus.config     DESTINATION ${KDE_INSTALL_DATADIR}/kwave)
INSTALL(FILES ${kwave_PIXMAPS} DESTINATION ${KDE_INSTALL_DATADIR}/kwave/pics)
INSTALL(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kwave.desktop
    DESTINATION ${KDE_INSTALL_APPDIR}
)

# application icon
ECM_INSTALL_ICONS(
    ICONS ${CMAKE_CURRENT_SOURCE_DIR}/pics/sc-apps-kwave.svgz
    DESTINATION ${KDE_INSTALL_ICONDIR}
)

# AppData file
INSTALL(
    FILES org.kde.kwave.appdata.xml
    DESTINATION ${KDE_INSTALL_METAINFODIR}
)

#############################################################################
#############################################################################

=== plugins/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/CMakeLists.txt
##                           -------------------
##    begin                : Mon May 28 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
#                                                                           #
# Redistribution and use in source and binary forms, with or without        #
# modification, are permitted provided that the following conditions        #
# are met:                                                                  #
#                                                                           #
# 1. Redistributions of source code must retain the above copyright         #
#    notice, this list of conditions and the following disclaimer.          #
# 2. Redistributions in binary form must reproduce the above copyright      #
#    notice, this list of conditions and the following disclaimer in the    #
#    documentation and/or other materials provided with the distribution.   #
#                                                                           #
# For details see the accompanying cmake/COPYING-CMAKE-SCRIPTS file.        #
#                                                                           #
#############################################################################

MACRO(KWAVE_PLUGIN _plugin)

    #########################################################################
    ### compile stage                                                     ###

    INCLUDE_DIRECTORIES(
        ${CMAKE_CURRENT_SOURCE_DIR}
        ${CMAKE_CURRENT_BINARY_DIR}
    )
    KI18N_WRAP_UI(plugin_${_plugin}_LIB_SRCS ${plugin_${_plugin}_LIB_UI})

    #########################################################################
    ### link stage                                                        ###

    ADD_LIBRARY(plugin_${_plugin} MODULE ${plugin_${_plugin}_LIB_SRCS})
    TARGET_LINK_LIBRARIES(plugin_${_plugin}
        libkwavegui
        libkwave
        ${plugin_${_plugin}_LIBS}
        ${SAMPLERATE_LINK_LIBRARIES}
        Qt::Core
        Qt::Concurrent
        Qt::Widgets
        KF6::ConfigCore
        KF6::CoreAddons
        KF6::I18n
        KF6::IconThemes
        KF6::KIOFileWidgets
        KF6::TextWidgets
        KF6::WidgetsAddons
        KF6::XmlGui
    )

    SET_TARGET_PROPERTIES(plugin_${_plugin} PROPERTIES
        OUTPUT_NAME "${_plugin}"
        LINK_FLAGS "-Wl,--export-dynamic"
        ENABLE_EXPORTS TRUE
        POSITION_INDEPENDENT_CODE ON
    )
    SET(LIBRARY_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})

    CONFIGURE_FILE(
        ${CMAKE_CURRENT_SOURCE_DIR}/kwaveplugin_${_plugin}.json.in
        ${CMAKE_CURRENT_BINARY_DIR}/kwaveplugin_${_plugin}.json
    )

    #########################################################################
    ### install                                                           ###

    INSTALL(TARGETS
        plugin_${_plugin}
        LIBRARY
        DESTINATION ${KDE_INSTALL_PLUGINDIR}/kwave
    )

ENDMACRO(KWAVE_PLUGIN)

#############################################################################

ADD_SUBDIRECTORY( about )
ADD_SUBDIRECTORY( amplifyfree )
ADD_SUBDIRECTORY( band_pass )
ADD_SUBDIRECTORY( codec_ascii )
ADD_SUBDIRECTORY( codec_audiofile ) # needs libaudiofile
ADD_SUBDIRECTORY( codec_flac )      # needs >= libflac 1.2.0
ADD_SUBDIRECTORY( codec_mp3 )       # needs libmad + id3lib + "lame"
ADD_SUBDIRECTORY( codec_ogg )       # needs libogg and (libvorbis or libopus)
ADD_SUBDIRECTORY( codec_wav )       # needs libaudiofile
ADD_SUBDIRECTORY( debug )
ADD_SUBDIRECTORY( export_k3b )
ADD_SUBDIRECTORY( fileinfo )
ADD_SUBDIRECTORY( goto )
ADD_SUBDIRECTORY( lowpass )
ADD_SUBDIRECTORY( newsignal )
ADD_SUBDIRECTORY( noise )
ADD_SUBDIRECTORY( normalize )
ADD_SUBDIRECTORY( notch_filter )
ADD_SUBDIRECTORY( pitch_shift )
ADD_SUBDIRECTORY( playback )        # needs one of: OSS/ALSA/PulseAudio
ADD_SUBDIRECTORY( record )          # needs OSS and/or ALSA
ADD_SUBDIRECTORY( reverse )
ADD_SUBDIRECTORY( samplerate )      # needs libsamplerate
ADD_SUBDIRECTORY( saveblocks )
ADD_SUBDIRECTORY( selectrange )
ADD_SUBDIRECTORY( sonagram )        # needs fftw >= 3.0
ADD_SUBDIRECTORY( stringenter )
ADD_SUBDIRECTORY( volume )
ADD_SUBDIRECTORY( zero )

#############################################################################
#############################################################################

=== plugins/export_k3b/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/export_k3b/CMakeLists.txt
##                           -------------------
##    begin                : Thu Mar 23 2017
##    copyright            : (C) 2017 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
#                                                                           #
# Redistribution and use in source and binary forms, with or without        #
# modification, are permitted provided that the following conditions        #
# are met:                                                                  #
#                                                                           #
# 1. Redistributions of source code must retain the above copyright         #
#    notice, this list of conditions and the following disclaimer.          #
# 2. Redistributions in binary form must reproduce the above copyright      #
#    notice, this list of conditions and the following disclaimer in the    #
#    documentation and/or other materials provided with the distribution.   #
#                                                                           #
# For details see the accompanying cmake/COPYING-CMAKE-SCRIPTS file.        #
#                                                                           #
#############################################################################

SET(plugin_export_k3b_LIB_SRCS
    K3BExportDialog.cpp
    K3BExportPlugin.cpp
    K3BExportWidget.cpp

    K3BExportDialog.h
    K3BExportPlugin.h
    K3BExportWidget.h
)

SET(plugin_export_k3b_LIB_UI
    K3BExportWidgetBase.ui
)

SET(plugin_export_k3b_LIBS
    KF6::Archive
)

KWAVE_PLUGIN(export_k3b)

#############################################################################
#############################################################################

=== plugins/saveblocks/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/saveblocks/CMakeLists.txt
##                           -------------------
##    begin                : Sat Jun 02 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
#                                                                           #
# Redistribution and use in source and binary forms, with or without        #
# modification, are permitted provided that the following conditions        #
# are met:                                                                  #
#                                                                           #
# 1. Redistributions of source code must retain the above copyright         #
#    notice, this list of conditions and the following disclaimer.          #
# 2. Redistributions in binary form must reproduce the above copyright      #
#    notice, this list of conditions and the following disclaimer in the    #
#    documentation and/or other materials provided with the distribution.   #
#                                                                           #
# For details see the accompanying cmake/COPYING-CMAKE-SCRIPTS file.        #
#                                                                           #
#############################################################################

SET(plugin_saveblocks_LIB_SRCS
    SaveBlocksDialog.cpp
    SaveBlocksPlugin.cpp
    SaveBlocksWidget.cpp

    SaveBlocksDialog.h
    SaveBlocksPlugin.h
    SaveBlocksWidget.h
)

SET(plugin_saveblocks_LIB_UI
    SaveBlocksWidgetBase.ui
)

KWAVE_PLUGIN(saveblocks)

#############################################################################
#############################################################################

=== debian/changelog ===
kwave (24.12.3-0ubuntu2) plucky; urgency=medium

  * No-change rebuild for flac.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sat, 15 Mar 2025 09:51:21 -0500

kwave (24.12.3-0ubuntu1) plucky; urgency=medium

  * New upstream release (24.12.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 06 Mar 2025 08:48:58 +0000

kwave (24.12.2-1ubuntu1) plucky; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Kubuntu Vcs and maintainer fields.

 -- Rik Mills <rikmills@kde.org>  Mon, 24 Feb 2025 21:08:13 +0000

## kwave 25.04.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -23,9 +23,9 @@
 #############################################################################
 
 # KDE Application Version, managed by release script
-set (RELEASE_SERVICE_VERSION_MAJOR "24")
-set (RELEASE_SERVICE_VERSION_MINOR "12")
-set (RELEASE_SERVICE_VERSION_MICRO "3")
+set (RELEASE_SERVICE_VERSION_MAJOR "25")
+set (RELEASE_SERVICE_VERSION_MINOR "04")
+set (RELEASE_SERVICE_VERSION_MICRO "0")
 
 #############################################################################
 ### build options:                                                        ###
@@ -38,7 +38,6 @@
 # OPTION(WITH_OGG_OPUS   "enable support for ogg/opus files [default=on]" ON)
 # OPTION(WITH_OGG_VORBIS "enable support for ogg/vorbis files [default=on]" ON)
 # OPTION(WITH_OSS        "enable playback/recording via OSS [default=on]" ON)
-# OPTION(WITH_OPTIMIZED_MEMCPY "enable optimized memcpy [default=on]" ON)
 # OPTION(WITH_PULSEAUDIO "enable playback/recording via PulseAudio [default=on]" ON)
 # OPTION(WITH_QT_AUDIO   "enable playback via Qt Multimedia [default=on]" ON)
 
@@ -47,15 +46,10 @@
 
 # all                 - default target, build all files
 # clean               - clean up the current build directory
-# deb                 - create a debian package
 # doc                 - generate docbook files for online help
-# distfiles           - generate subdirectory with all files for distribution
 # html_doc            - generate HTML help (for the web)
 # install             - install the package, with support for DESTDIR
 # msgstats            - show the progress of translations
-# rpm                 - create a RPM package + a src.rpm file
-# src_rpm             - create the source RPM only
-# tarball             - create a tar.bz2 archive with the sources + specfile
 # uninstall           - uninstall the package, with support for DESTDIR
 # update-translations - update translation files from KDE SVN
 # version-labels      - update all version numbers and build dates
@@ -67,8 +61,7 @@
 CMAKE_MINIMUM_REQUIRED(VERSION 3.16.0 FATAL_ERROR)
 
 SET(QT_MIN_VERSION "6.6.0")
-SET(KF_MIN_VERSION "6.0.0")
-SET(KDE_COMPILERSETTINGS_LEVEL "5.82")
+SET(KF_MIN_VERSION "6.9.0")
 
 set(CMAKE_CXX_STANDARD 20)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
@@ -98,45 +91,6 @@
 )
 GET_FILENAME_COMPONENT(COMPILER_SHORT "${CMAKE_C_COMPILER}" NAME_WE CACHE)
 MESSAGE(STATUS "Building with ${COMPILER_SHORT} version ${COMPILER_VERSION}")
-
-#############################################################################
-### check for the CPU we build for                                        ###
-
-EXECUTE_PROCESS(
-    COMMAND ${CMAKE_C_COMPILER} -dumpmachine
-    OUTPUT_VARIABLE MACHINE
-    OUTPUT_STRIP_TRAILING_WHITESPACE
-)
-MESSAGE(STATUS "Building for target ${MACHINE}")
-
-OPTION(WITH_OPTIMIZED_MEMCPY "enable optimized memcpy [default=on]" ON)
-IF (WITH_OPTIMIZED_MEMCPY)
-
-    STRING(REGEX MATCH "(i.86-*)|(athlon-*)|(pentium-*)" _mach_x86 ${MACHINE})
-    IF (_mach_x86)
-        MESSAGE(STATUS "Found target optimized memcpy() for X86 (from xine)")
-        SET(ARCH_X86 1)
-    ENDIF (_mach_x86)
-
-    STRING(REGEX MATCH "(x86_64-*)|(X86_64-*)|(AMD64-*)|(amd64-*)" _mach_x86_64 ${MACHINE})
-    IF (_mach_x86_64)
-        MESSAGE(STATUS "Found target optimized memcpy() for X86_64 (from xine)")
-        SET(ARCH_X86_64 1)
-    ENDIF (_mach_x86_64)
-
-    STRING(REGEX MATCH "(ppc-*)|(powerpc-*)" _mach_ppc ${MACHINE})
-    IF (_mach_ppc)
-        MESSAGE(STATUS "Found target optimized memcpy() for PPC (from xine)")
-        SET(ARCH_PPC 1)
-    ENDIF (_mach_ppc)
-
-    IF (NOT ARCH_X86 AND NOT ARCH_X86_64 AND NOT ARCH_PPC)
-        MESSAGE(STATUS "No platform specific memcpy available")
-    ENDIF (NOT ARCH_X86 AND NOT ARCH_X86_64 AND NOT ARCH_PPC)
-
-ELSE (WITH_OPTIMIZED_MEMCPY)
-    MESSAGE(STATUS "Platform specific memcpy is disabled")
-ENDIF (WITH_OPTIMIZED_MEMCPY)
 
 #############################################################################
 ### path to additional cmake modules and includes                         ###
@@ -157,10 +111,6 @@
 ### toplevel compiler flags                                               ###
 
 ADD_DEFINITIONS(-DHAVE_CONFIG_H)
-ADD_DEFINITIONS(-DQT_NO_CAST_TO_ASCII)
-ADD_DEFINITIONS(-DQT_NO_CAST_FROM_ASCII)
-ADD_DEFINITIONS(-DQT_USE_FAST_OPERATOR_PLUS)
-ADD_DEFINITIONS(-DQT_NO_URL_CAST_FROM_STRING)
 
 #############################################################################
 
@@ -201,13 +151,17 @@
 
 INCLUDE(KDEInstallDirs)
 INCLUDE(KDECompilerSettings NO_POLICY_SCOPE)
+REMOVE_DEFINITIONS(
+    -DQT_NO_FOREACH
+    -DQT_NO_KEYWORDS
+)
 INCLUDE(KDECMakeSettings)
 INCLUDE(ECMGenerateExportHeader)
 INCLUDE(FeatureSummary)
 INCLUDE(ECMDeprecationSettings)
 ecm_set_disabled_deprecation_versions(
-  QT 6.7.0
-  KF 6.5.0
+  QT 6.8.0
+  KF 6.10.0
 )
 
 FIND_PACKAGE(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS
@@ -301,3 +255,41 @@
 ADD_SUBDIRECTORY( plugins )
 
 OPTION(WITH_DOC "build online documentation [default=on]" ON)
+IF (WITH_DOC)
+    ADD_SUBDIRECTORY( doc )
+ENDIF (WITH_DOC)
+
+#############################################################################
+
+CONFIGURE_FILE(
+    ${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake
+    ${CMAKE_CURRENT_BINARY_DIR}/config.h
+)
+
+#############################################################################
+### KDE .desktop file / mime types                                        ###
+
+SET(KWAVE_DESKTOP_MIME_TYPES "${KWAVE_DESKTOP_MIME_TYPES}audio/wav;")
+SET(KWAVE_DESKTOP_MIME_TYPES "${KWAVE_DESKTOP_MIME_TYPES}audio/x-wav;")
+SET(KWAVE_DESKTOP_MIME_TYPES "${KWAVE_DESKTOP_MIME_TYPES}audio/basic;")
+SET(KWAVE_DESKTOP_MIME_TYPES "${KWAVE_DESKTOP_MIME_TYPES}audio/x-8svx;")
+SET(KWAVE_DESKTOP_MIME_TYPES "${KWAVE_DESKTOP_MIME_TYPES}audio/x-aifc;")
+SET(KWAVE_DESKTOP_MIME_TYPES "${KWAVE_DESKTOP_MIME_TYPES}audio/x-aiff;")
+SET(KWAVE_DESKTOP_MIME_TYPES "${KWAVE_DESKTOP_MIME_TYPES}audio/x-avr;")
+SET(KWAVE_DESKTOP_MIME_TYPES "${KWAVE_DESKTOP_MIME_TYPES}audio/x-caf;")
+SET(KWAVE_DESKTOP_MIME_TYPES "${KWAVE_DESKTOP_MIME_TYPES}audio/x-ircam;")
+SET(KWAVE_DESKTOP_MIME_TYPES "${KWAVE_DESKTOP_MIME_TYPES}audio/x-nist;")
+SET(KWAVE_DESKTOP_MIME_TYPES "${KWAVE_DESKTOP_MIME_TYPES}audio/x-smp;")
+SET(KWAVE_DESKTOP_MIME_TYPES "${KWAVE_DESKTOP_MIME_TYPES}audio/x-voc;")
+IF (WITH_MP3)
+    SET(KWAVE_DESKTOP_MIME_TYPES "${KWAVE_DESKTOP_MIME_TYPES}audio/mpeg;")
+    SET(KWAVE_DESKTOP_MIME_TYPES "${KWAVE_DESKTOP_MIME_TYPES}audio/x-mp1;")
+    SET(KWAVE_DESKTOP_MIME_TYPES "${KWAVE_DESKTOP_MIME_TYPES}audio/x-mp2;")
+    SET(KWAVE_DESKTOP_MIME_TYPES "${KWAVE_DESKTOP_MIME_TYPES}audio/x-mp3;")
+ENDIF (WITH_MP3)
+IF (WITH_FLAC)
+    SET(KWAVE_DESKTOP_MIME_TYPES "${KWAVE_DESKTOP_MIME_TYPES}application/x-flac;")
+    SET(KWAVE_DESKTOP_MIME_TYPES "${KWAVE_DESKTOP_MIME_TYPES}audio/x-flac;")
+ENDIF (WITH_FLAC)
+IF (WITH_OGG_OPUS OR WITH_OGG_VORBIS)
+    SET(KWAVE_DESKTOP_MIME_TYPES "${KWAVE_DESKTOP_MIME_TYPES}audio/ogg;")

=== plugins/fileinfo/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/fileinfo/CMakeLists.txt
##                           -------------------
##    begin                : Sat Jun 02 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
#                                                                           #
# Redistribution and use in source and binary forms, with or without        #
# modification, are permitted provided that the following conditions        #
# are met:                                                                  #
#                                                                           #
# 1. Redistributions of source code must retain the above copyright         #
#    notice, this list of conditions and the following disclaimer.          #
# 2. Redistributions in binary form must reproduce the above copyright      #
#    notice, this list of conditions and the following disclaimer in the    #
#    documentation and/or other materials provided with the distribution.   #
#                                                                           #
# For details see the accompanying cmake/COPYING-CMAKE-SCRIPTS file.        #
#                                                                           #
#############################################################################

SET(plugin_fileinfo_LIB_SRCS
    BitrateSpinBox.cpp
    BitrateWidget.cpp
    CompressionWidget.cpp
    FileInfoDialog.cpp
    FileInfoPlugin.cpp
    KeywordWidget.cpp
    SelectDateDialog.cpp

    BitrateSpinBox.h
    BitrateWidget.h
    CompressionWidget.h
    FileInfoDialog.h
    FileInfoPlugin.h
    KeywordWidget.h
    SelectDateDialog.h
)

SET(plugin_fileinfo_LIB_UI
    BitrateWidgetBase.ui
    CompressionWidgetBase.ui
    FileInfoDlg.ui
    KeywordWidgetBase.ui
    SelectDateDlg.ui
)

KWAVE_PLUGIN(fileinfo)

#############################################################################
#############################################################################

=== plugins/goto/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/goto/CMakeLists.txt
##                           -------------------
##    begin                : Sat Dec 06 2008
##    copyright            : (C) 2008 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
#                                                                           #
# Redistribution and use in source and binary forms, with or without        #
# modification, are permitted provided that the following conditions        #
# are met:                                                                  #
#                                                                           #
# 1. Redistributions of source code must retain the above copyright         #
#    notice, this list of conditions and the following disclaimer.          #
# 2. Redistributions in binary form must reproduce the above copyright      #
#    notice, this list of conditions and the following disclaimer in the    #
#    documentation and/or other materials provided with the distribution.   #
#                                                                           #
# For details see the accompanying cmake/COPYING-CMAKE-SCRIPTS file.        #
#                                                                           #
#############################################################################

SET(plugin_goto_common_LIB_SRCS
    GotoDialog.cpp
    GotoPluginBase.cpp

    GotoDialog.h
    GotoPluginBase.h
)

SET(plugin_goto_common_LIB_UI
    GotoDlg.ui
)

KI18N_WRAP_UI(plugin_goto_common_LIB_SRCS ${plugin_goto_common_LIB_UI})
ADD_LIBRARY(plugin_goto_common STATIC ${plugin_goto_common_LIB_SRCS})
SET_TARGET_PROPERTIES(plugin_goto_common PROPERTIES ENABLE_EXPORTS ON)
set_target_properties(plugin_goto_common PROPERTIES POSITION_INDEPENDENT_CODE ON)
TARGET_LINK_LIBRARIES(plugin_goto_common
    libkwavegui
    libkwave
    Qt::Core
    Qt::Widgets
    KF6::ConfigWidgets
    KF6::CoreAddons
    KF6::I18n
)

#############################################################################

SET(plugin_goto_LIB_SRCS
    GotoPlugin.cpp
    GotoPlugin.h
)

SET(plugin_goto_LIBS plugin_goto_common)
KWAVE_PLUGIN(goto)

#############################################################################

SET(plugin_insert_at_LIB_SRCS
    InsertAtPlugin.cpp
    InsertAtPlugin.h
)

SET(plugin_insert_at_LIBS plugin_goto_common)
KWAVE_PLUGIN(insert_at)

#############################################################################
#############################################################################

=== plugins/volume/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/volume/CMakeLists.txt
##                           -------------------
##    begin                : Sat Jun 02 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
#                                                                           #
# Redistribution and use in source and binary forms, with or without        #
# modification, are permitted provided that the following conditions        #
# are met:                                                                  #
#                                                                           #
# 1. Redistributions of source code must retain the above copyright         #
#    notice, this list of conditions and the following disclaimer.          #
# 2. Redistributions in binary form must reproduce the above copyright      #
#    notice, this list of conditions and the following disclaimer in the    #
#    documentation and/or other materials provided with the distribution.   #
#                                                                           #
# For details see the accompanying cmake/COPYING-CMAKE-SCRIPTS file.        #
#                                                                           #
#############################################################################

SET(plugin_volume_LIB_SRCS
    VolumeDialog.cpp
    VolumePlugin.cpp

    VolumeDialog.h
    VolumePlugin.h
)

SET(plugin_volume_LIB_UI
    VolumeDlg.ui
)

KWAVE_PLUGIN(volume)

#############################################################################
#############################################################################

=== debian/changelog ===
kwave (25.04.0-2) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * Update project homepage.

 -- Aurélien COUDERC <coucouf@debian.org>  Sun, 04 May 2025 15:45:59 +0200

kwave (25.04.0-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * New upstream release (25.04.0).
  * Update build-deps and deps with the info from cmake.
  * Refresh copyright information.
  * Bump Standards-Version to 4.7.2, no change required.
  * Update project homepage.
  * Remove inactive uploaders.
  * Add lintian override for GUI program without command line arguments
    not shipping a manual.

 -- Aurélien COUDERC <coucouf@debian.org>  Thu, 17 Apr 2025 22:01:40 +0200

=== debian/control ===
Source: kwave
Section: kde
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-sequence-kf6,
               cmake (>= 3.16.0~),
               extra-cmake-modules (>= 6.9.0~),
               gettext,
               libasound2-dev [linux-any],
               libaudiofile-dev (>> 0.3.0),
               libfftw3-dev,
               libflac++-dev (>= 1.1.4),
               libid3-3.8.3-dev (>= 3.8.3-4.2),
               libkf6archive-dev (>= 6.9.0~),
               libkf6completion-dev (>= 6.9.0~),
               libkf6config-dev (>= 6.9.0~),
               libkf6configwidgets-dev (>= 6.9.0~),
               libkf6coreaddons-dev (>= 6.9.0~),
               libkf6crash-dev (>= 6.9.0~),
               libkf6dbusaddons-dev (>= 6.9.0~),
               libkf6doctools-dev (>= 6.9.0~),
               libkf6i18n-dev (>= 6.9.0~),
               libkf6iconthemes-dev (>= 6.9.0~),
               libkf6kio-dev (>= 6.9.0~),
               libkf6textwidgets-dev (>= 6.9.0~),
               libkf6widgetsaddons-dev (>= 6.9.0~),
               libkf6xmlgui-dev (>= 6.9.0~),
               libmad0-dev,
               libogg-dev,
               libopus-dev (>= 1.0.0),
               libpulse-dev,
               librsvg2-bin,
               libsamplerate0-dev,
               libvorbis-dev (>= 1.0.0-2),
               pkgconf,
               qt6-base-dev (>= 6.6.0~),
               qt6-multimedia-dev (>= 6.6.0~),
               xauth <!nocheck>,
               xvfb <!nocheck>,
Homepage: https://vvave.kde.org/
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kwave.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kwave
Rules-Requires-Root: no

Package: kwave
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: sound editor for KDE
 Kwave is a sound editor designed for the KDE Desktop Environment.
 .
 With Kwave you can record, play back, import and edit many sorts of audio
 files including multi-channel files.
 .
 Kwave includes some plugins to transform audio files in several ways and
 presents a graphical view with a complete zoom- and scroll capability.
 .
 Its features include:
  * 24 Bit Support
  * Undo/Redo
  * Use of multicore CPUs (SMP, hyperthreading)
  * Simple Drag & Drop
  * Realtime Pre-Listen for some effects
  * Support for multi-track files
  * Playback and recording via native ALSA, PulseAudio (or OSS deprecated)
  * Playback via Phonon
  * Load and edit-capability for large files (can use virtual memory)
  * Reading and auto-repair of damaged wav-files
  * Supports multiple windows
  * Extendable Plugin interface
  * a nice splashscreen
  * some label handling

## kwave 25.04.3

=== debian/changelog ===
kwave (25.04.3-0ubuntu1) questing; urgency=medium

  * New upstream release (25.04.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 03 Jul 2025 07:53:41 +0100

kwave (25.04.2-0ubuntu1) questing; urgency=medium

  * New upstream release (25.04.2)

 -- Rik Mills <rikmills@kde.org>  Thu, 05 Jun 2025 11:58:02 +0100

kwave (25.04.1-0ubuntu1) questing; urgency=medium

  * New upstream release (25.04.1)

 -- Rik Mills <rikmills@kde.org>  Wed, 07 May 2025 22:15:55 +0100

kwave (25.04.0-0ubuntu1) questing; urgency=medium

  * New upstream release (25.04.0)

 -- Rik Mills <rikmills@kde.org>  Wed, 30 Apr 2025 20:00:28 +0100

## kwave 25.07.80

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,8 +24,8 @@
 
 # KDE Application Version, managed by release script
 set (RELEASE_SERVICE_VERSION_MAJOR "25")
-set (RELEASE_SERVICE_VERSION_MINOR "04")
-set (RELEASE_SERVICE_VERSION_MICRO "0")
+set (RELEASE_SERVICE_VERSION_MINOR "07")
+set (RELEASE_SERVICE_VERSION_MICRO "80")
 
 #############################################################################
 ### build options:                                                        ###

=== debian/changelog ===
kwave (25.07.80-0ubuntu1) questing; urgency=medium

  * New upstream (beta) release (25.07.80)

 -- Rik Mills <rikmills@kde.org>  Sat, 12 Jul 2025 18:23:02 +0100

## kwave 25.07.90

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 # KDE Application Version, managed by release script
 set (RELEASE_SERVICE_VERSION_MAJOR "25")
 set (RELEASE_SERVICE_VERSION_MINOR "07")
-set (RELEASE_SERVICE_VERSION_MICRO "80")
+set (RELEASE_SERVICE_VERSION_MICRO "90")
 
 #############################################################################
 ### build options:                                                        ###

=== debian/changelog ===
kwave (25.07.90-0ubuntu1) questing; urgency=medium

  * New upstream (RC) release (25.07.90)

 -- Rik Mills <rikmills@kde.org>  Fri, 25 Jul 2025 17:57:57 +0100
